﻿unit Unit2;


interface
{$OPTIMIZATION OFF}

uses

  windows, messages, sysutils, variants, Classes,
  Controls, Dialogs, ComCtrls,  Math, ExtCtrls, StdCtrls, ExtDlgs,
  Forms, Graphics, Vcl.Imaging.jpeg,
  unTFLite, unTFLiteResults,
  Vcl.AppEvnts;

type

  { TForm1 }

  TForm1 = class(TForm)
    Image2: TImage;
    Button2: TButton;
    Edit1: TEdit;
    Label2: TLabel;
    Button1: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    lblVersion: TLabel;
    lblMess: TLabel;
    btnLoad: TButton;
    lbl1: TLabel;
    txScore: TEdit;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnLoadClick(Sender: TObject);
  private
    { Private declarations }
    bmp: TBitmap;
    tflite:  TTFLiteSSDMobilenet;

    procedure loadModel(name: string);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation


{$R *.dfm}

procedure TForm1.loadModel(name: string);
begin
try
    if Assigned(tflite) then
        tflite.Free;
    tflite:=TTFLiteSSDMobilenet.create(name, 'labelmap-coco.txt');
    tflite.minScore:=0.35;
    Image2.Width := tflite.inputWidth;
    Image2.Height := tflite.inputHeight;
except
  on E: Exception do
  begin
    ShowMessage(e.Message );
    Halt(999);
  end;
end;

end;


procedure TForm1.btnLoadClick(Sender: TObject);
begin
    loadModel(Edit1.Text);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  fBitmap: TBitmap;
  fJpg: TJPEGImage;
  ext: string;
begin
  if OpenPictureDialog1.Execute then
  begin
    try
         ext:=UpperCase(ExtractFileExt(OpenPictureDialog1.FileName)) ;
         fBitmap := TBitmap.Create;
         fBitmap.PixelFormat:=pf24bit;
         if (ext='.BMP') then
         begin
               fBitmap.LoadFromFile(OpenPictureDialog1.FileName);
               Image2.Picture.Bitmap.Canvas.StretchDraw(Image2.ClientRect, fBitmap );
               fBitmap.Free;
         end;
         if (ext='.JPG') or (ext='.JPEG') then
         begin
             fJpg:=TJPEGImage.Create;
             fJpg.LoadFromFile(OpenPictureDialog1.FileName);
             Image2.Picture.Bitmap.Canvas.StretchDraw(Image2.ClientRect, fJpg );
             fJpg.Free;
         end;
    finally
    end;

  end;
end;

procedure TForm1.Button2Click(Sender: TObject);


var
  i: Integer;
  outlst: TTFlstResults;
  tfres: TTFResult;
  tfboxres: TTFBoxResult;
 { Variables }
   Freq, StartCount, StopCount: Int64;
   TimingSeconds: real;
begin
  outlst:=TTFlstResults.Create();
  bmp:=TBitmap.Create;
  bmp.Assign(Image2.Picture.Bitmap);
  tflite.minScore:=StrToFloat(txScore.Text);

  lblMess.Caption:='Detecting....';
  Application.ProcessMessages;
 { Precise measurement of time in ms }
 QueryPerformanceFrequency(Freq);
  QueryPerformanceCounter(StartCount);

  tflite.doPrediction(bmp, outlst);

  QueryPerformanceCounter(StopCount);
  // sec
  TimingSeconds := (StopCount - StartCount) / Freq;
  for tfres in outlst do
  begin
      Image2.Canvas.Brush.Style := bsClear;
      Image2.Canvas.FillRect(Image2.Canvas.ClipRect);
      Image2.Canvas.Pen.Color := clRed;
      Image2.Canvas.Rectangle(TTFBoxResult(tfres).posrect);

      Image2.Canvas.Brush.Style := bsSolid;
      Image2.Canvas.Brush.Color := clRed;
      Image2.Canvas.Font.Color := clWhite;
      Image2.Canvas.TextOut(TTFBoxResult(tfres).posrect.Left + 2, TTFBoxResult(tfres).posrect.Top + 1,
        tfres.labelname + ' - '  + FloatToStr(RoundTo(tfres.score,-2)));

  end;
  // Display timing: ...
  lblMess.Caption:='Done in sec '+FloatToStr(TimingSeconds);

  bmp.Free;
  outlst.Free;
end;



procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  tflite.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  OpenPictureDialog1.InitialDir := GetCurrentDir;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
    loadModel(Edit1.Text);
    lblVersion.Caption:='TfLite version '+string(tflite.version);
end;



end.
